#!/bin/bash

clear
vclam=$(ls /usr/share/doc/|grep clamd)

echo "---------------------------------------------------------------------"
echo "--               CCN-STIC-681_ENS_ADICIONAL_AMAVIS                 --"
echo "--  Antes de ejecutar este script debe asegurarse que los ficheros --"
echo "--       y scripts se encuentran en el directorio /Scripts         --"
echo "---------------------------------------------------------------------"
echo " "
echo "------------------------------------------------------------------"
echo "-- SE VA A PROCEDER A CONFIGURAR CLAMAV, SPAMASSASSIN Y AMAVISD --"
echo "-------- PARA ELLO SE VA A REALIZAR COPIA DE SEGURIDAD -----------"
echo "---------- DE LOS SIGUIENTES ARCHIVOS DE CONFIGURACION -----------"
echo "------------------------------------------------------------------"
echo " "
echo " "
echo "
/usr/share/doc/$vclam/clamd.sysconfig
/etc/sysconfig/clamd.amavisd
/etc/tmpfiles.d/clamd.amavisd.conf
/usr/lib/systemd/system/clamd@.service
/etc/mail/spamassassin/local.cf

LA UBICACION DE LAS COPIAS DE SEGURIDAD, SON LAS MISMAS QUE DE LOS ARCHIVOS
ORIGINALES, TERMINADOS CON LA FECHA Y HORA DEL MOMENTO DE LA MODIFICACION"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"

###########################################Variables##################################################

echo " "
echo "----------------------------------------------------------------------"
echo "-- SE DEFINEN LA VARIABLES DE SU ORGANIZACION PARA LA CONFIGURACION --"
echo "----------------------------------------------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"

echo "  "
echo "Escriba el nombre de dominio"
read domain
echo " "
echo "Escriba el nombre del equipo:"
read hostname
vclam=$(ls /usr/share/doc/|grep clamd)
fecha=$(date +%d-%m-%Y_%H:%M)

###########################################Spamassassin##################################################

echo "----------------------------------------------------------"
echo "-- SE PROCEDE A CONFIGURAR USUARIOS Y GRUPOS NECESARIOS --"
echo "----------------------------------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"


cp -f /etc/mail/spamassassin/local.cf /etc/mail/spamassassin/local.cf.$fecha

#COMPROBACION DE USUARIO Y HOME
echo " "
echo " "
cat /etc/passwd | grep spamd
if [ $? = 0 ]; then
echo -e "Usuario spamd \e[42mExiste\e[49m"
else
echo "Se procedera a crear el usuario: spamd"
groupadd spamd
useradd spamd -g spamd -s /bin/false -d /var/log/spamassassin spamd
chown spamd:spamd /var/log/spamassassin
sleep 2
fi
echo " "

cat /etc/passwd | grep amavis
if [ $? = 0 ]; then
echo -e "Usuario amavis \e[42mExiste\e[49m"
usermod amavis -s /bin/false
else
echo "Se procedera a crear el usuario: amavis"
groupadd amavis
useradd amavis -g amavis -s /bin/false -d /var/spool/amavisd
fi
echo " "

cat /etc/passwd | grep clamupdate
if [ $? = 0 ]; then
echo -e "Usuario clamupdate \e[42mExiste\e[49m"
usermod clamupdate -s /bin/false
else
echo "Se procedera a crear el usuario: clamupdate"
groupadd clamupdate
useradd clamupdate -g clamupdate -s /bin/false -d /var/lib/clamav
fi
echo " "

cat /etc/passwd | grep clamscan
if [ $? = 0 ]; then
echo -e "Usuario clamscan \e[42mExiste\e[49m"
usermod clamscan -s /bin/false
else
echo "Se procedera a crear el usuario: clamscan"
groupadd clamscan
useradd clamscan -g clamscan -s "/bin/false"
fi

echo " "
echo "------------------------------------------"
echo "-- SE PROCEDE A CONFIGURAR SPAMASSASSIN --"
echo "------------------------------------------"
echo " "
#COMPROBACION/CREACION ARCHIVO DE CONFIGURACION

ls /etc/mail/spamassassin/local.cf 
if [ $? = 0 ]; then
echo -e "/etc/mail/spamassassin/local.cf \e[42mEXISTE\e[49m"
sed -i 's/^/#/g' /etc/mail/spamassassin/local.cf
else
echo "Se procedera a crear /etc/mail/spamassassin/local.cf"
mkdir /etc/mail/spamassassin/
sleep 2
touch /etc/mail/spamassassin/local.cf
fi

echo " "
echo " "
echo "Escriba la advertencia que aparecera cuando se reciba spam:"
read mensaje
echo " "
echo " "

cp -f /usr/share/spamassassin/23_bayes.cf /var/log/spamassassin

echo " 
#Puntacion de marca de spamassassin
required_hits 5
#mensaje antepuesto al asunto de mensaje spam
rewrite_header Subject ['$mensaje']
#encapsular el spam en un adjunto al email de aviso
report_safe 1
#habilitar bayes
use_bayes 1
#Autoaprendizaje
bayes_auto_learn 1
bayes_path /var/log/spamassassin/23_bayes.cf
bayes_file_mode 0666
#Comprobaciones de spam
skip_rbl_checks 0
use_razor2 1
#use_dcc 0
use_pyzor 1" >> /etc/mail/spamassassin/local.cf

#####################################################CLAMAV######################################################

echo "--------------------------------------"
echo "-- SEGUIDAMENTE SE CONFIGURA CLAMAV --"
echo "--------------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"

sed -i 's!#LocalSocket /var!LocalSocket /var!' /etc/clamd.d/scan.conf
cp -f /etc/freshclam.conf /etc/freshclam.conf.$fecha

sed -i -e "s/^Example/#Example/g" /etc/freshclam.conf
sed -i -e "s/^Example/#Example/g" /etc/clamd.d/scan.conf
freshclam
cp -f /usr/share/doc/$vclam/clamd.sysconfig /etc/sysconfig/clamd.amavisd
sleep 1
cp -f /etc/sysconfig/clamd.amavisd /etc/sysconfig/clamd.amavisd.$fecha
sed -i -e "1,2d" /etc/sysconfig/clamd.amavisd
echo "
CLAMD_CONFIGFILE=/etc/clamd.d/<SERVICE>.conf 
CLAMD_SOCKET=/var/run/clamd.<SERVICE>/clamd.sock" >> /etc/sysconfig/clamd.amavisd

touch /etc/tmpfiles.d/clamd.amavisd.conf
touch /etc/tmpfiles.d/clamd.amavisd.conf.$fecha

sleep 1

echo "d /var/run/clamd.amavisd 0755 amavis amavis -" >> /etc/tmpfiles.d/clamd.amavisd.conf

cp -f /usr/lib/systemd/system/clamd@.service /usr/lib/systemd/system/clamd@.service.$fecha

echo "
[Install]
WantedBy=multi-user.target " >> /usr/lib/systemd/system/clamd@.service

###########################################AMAVISD##################################################

echo " "
echo "----------------------------------------------"
echo "-- SE REALIZARA LA CONFIGURACION DE AMAVISD --"
echo "--       Y SU INTEGRACION CON POSTFIX       --"
echo "----------------------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"

cp -f /etc/amavisd/amavisd.conf /etc/amavisd/amavisd.conf.$fecha

sed -i 's/# $notify_method/$notify_method/' /etc/amavisd/amavisd.conf
sed -i 's/# $forward_method/$forward_method/' /etc/amavisd/amavisd.conf

sed -i 's/# $myhostname/$myhostname/' /etc/amavisd/amavisd.conf
sed -i 's|host.example.com|'$hostname'.'$domain'|' /etc/amavisd/amavisd.conf
sed -i 's|example.com|'$domain'|' /etc/amavisd/amavisd.conf

sleep 1

cp -f /etc/postfix/main.cf /etc/postfix/main.cf.$fecha
cp -f /etc/postfix/master.cf /etc/postfix/master.cf.$fecha

echo "
content_filter=smtp-amavis:[127.0.0.1]:10024" >> /etc/postfix/main.cf
echo -e "
smtp-amavis unix - - n - 2 smtp
\t-o smtp_data_done_timeout=1200
\t-o smtp_send_xforward_command=yes
\t-o disable_dns_lookups=yes
127.0.0.1:10025 inet n - n - - smtpd 
\t-o content_filter=
\t-o local_recipient_maps=
\t-o relay_recipient_maps=
\t-o smtpd_restriction_classes=
\t-o smtpd_client_restrictions=
\t-o smtpd_helo_restrictions=
\t-o smtpd_sender_restrictions=
\t-o smtpd_recipient_restrictions=permit_mynetworks,reject
\t-o mynetworks=127.0.0.0/8 # chequear
\t-o strict_rfc821_envelopes=yes
\t-o smtpd_error_sleep_time=0
\t-o smtpd_soft_error_limit=1001
\t-o smtpd_hard_error_limit=1000" >> /etc/postfix/master.cf

###########################################SELINUX##################################################

setsebool -P allow_postfix_local_write_mail_spool 1
setsebool -P spamassassin_can_network 1
setsebool -P spamd_enable_home_dirs 1
setsebool -P antivirus_can_scan_system on
setsebool -P daemons_dump_core 1


touch amavisdlocal.te
sleep 1
echo "module amavisdlocal 1.0;

require {
        type traceroute_port_t;
        type pgpkeyserver_port_t;
        type amavis_var_lib_t;
        type amavis_t;
        type clockspeed_port_t;
        class udp_socket name_bind;
        class lnk_file { read create unlink getattr };
}

#============= amavis_t ==============
allow amavis_t clockspeed_port_t:udp_socket name_bind;
allow amavis_t pgpkeyserver_port_t:udp_socket name_bind;
allow amavis_t traceroute_port_t:udp_socket name_bind;
allow amavis_t amavis_var_lib_t:lnk_file { read create unlink getattr };
" >> amavisdlocal.te

touch clamlocal.te
sleep 1
echo "
module clamlocal 1.0;

require {
        type proc_t;
        type var_t;
        type sysctl_kernel_t;
        type clamd_t;
        class file { read getattr };
        class dir { read search };
}

#============= clamd_t ==============
allow clamd_t proc_t:file { read getattr };
allow clamd_t sysctl_kernel_t:dir search;
allow clamd_t sysctl_kernel_t:file read;
allow clamd_t var_t:dir read;
allow clamd_t var_t:file { read getattr };" >> clamlocal.te

checkmodule -M -m -o amavisdlocal.mod amavisdlocal.te
semodule_package -o amavisdlocal.pp -m amavisdlocal.mod
semodule -i amavisdlocal.pp

checkmodule -M -m -o clamlocal.mod clamlocal.te
semodule_package -o clamlocal.pp -m clamlocal.mod
semodule -i clamlocal.pp

rm -f *.te *.pp *.mod

firewall-cmd --add-service=smtp --permanent
firewall-cmd --zone=public --add-port=10025/tcp --permanent
firewall-cmd --zone=public --add-port=10024/tcp --permanent

firewall-cmd --reload
##########################SERVICIOS Y CHECKS##############################

echo " "
echo "-----------------------------------"
echo "---- COMPROBANDO CONFIGURACION ----"
echo "-----------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"

echo " "
echo " "

spamassassin --lint
if [ $? = 0 ]; then
echo -e "CONFIGURACION SPAMASSASSIN \e[42mCORRECTA\e[49m"
else
echo " DEBERA ADAPTAR LA CONFIGURACION A LOS PAR?METROS DE SU ORGANIZACION"
fi

postfix check

if [ $? = 0 ]; then
echo -e "CONFIGURACION POSTFIX \e[42mCORRECTA\e[49m"
else
echo " DEBERA ADAPTAR LA CONFIGURACION A LOS PAR?METROS DE SU ORGANIZACION"
fi
systemctl enable spamassassin
systemctl start spamassassin
sa-update

systemctl start clamd@amavisd
systemctl enable clamd@amavisd

systemctl start amavisd
systemctl enable amavisd

systemctl restart postfix

echo " "
############################################################################
ls -lh /etc/freshclam.conf |grep '\-rw-r--r\--'
if [ $? = 0 ]; then
echo "freshclam.conf Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "Modificados los permisos de acceso a freshclam.conf"
chmod 644 /etc/freshclam.conf
fi
echo " "
ls -lh /etc/sysconfig/clamd.amavisd |grep root
if [ $? = 0 ]; then
echo "clamd.amavisd pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo "clamd.amavisd debera pertenecer a root"
echo  "Modificada la pertenencia a root del archivo clamd.amavisd"
chown root:root /etc/sysconfig/clamd.amavisd
fi

echo " "

ls -lh /etc/sysconfig/clamd.amavisd |grep '\-rw-r--r\--'
if [ $? = 0 ]; then
echo "clamd.amavisd Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "Modificados los permisos de acceso a clamd.amavisd"
chmod 644 /etc/sysconfig/clamd.amavisd
fi
echo " "
ls -lh /usr/share/doc/$vclam/clamd.sysconfig |grep root
if [ $? = 0 ]; then
echo "clamd.sysconfig SI pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo  "Modificada la pertenencia a root del archivo clamd.sysconfig" 
chown root /usr/share/doc/$vclam/clamd.sysconfig
fi

echo " "

ls -lh /usr/share/doc/$vclam/clamd.sysconfig |grep '\-rw-r--r\--'
if [ $? = 0 ]; then
echo "clamd.sysconfig Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "Modificados los permisos de acceso a clamd.sysconfig"
chmod 644 ls -lh /usr/share/doc/$vclam/clamd.sysconfig 
fi
echo " "
ls -lh /etc/tmpfiles.d/clamd.amavisd.conf |grep root
if [ $? = 0 ]; then
echo "clamd.amavisd.conf SI pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo  "Modificada la pertenencia a root del archivo clamd.amavisd.conf"
chown root /etc/tmpfiles.d/clamd.amavisd.conf
fi

echo " "

ls -lh /etc/tmpfiles.d/clamd.amavisd.conf |grep '\-rw-r--r\--'
if [ $? = 0 ]; then
echo "clamd.amavisd.conf Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "Modificados los permisos de acceso a clamd.amavisd.conf"
chmod 644 /etc/tmpfiles.d/clamd.amavisd.conf
fi
echo " "
ls -lh /usr/lib/systemd/system/clamd@.service |grep root
if [ $? = 0 ]; then
echo "clamd@.service SI pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo  "Modificada la pertenencia a root del archivo clamd@.service"
chown root /usr/lib/systemd/system/clamd@.service
fi

echo " "

ls -lh /usr/lib/systemd/system/clamd@.service |grep '\-rw-r--r\--'
if [ $? = 0 ]; then
echo "clamd@.service Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "Modificados los permisos de acceso a clamd@.service"
chmod 644 /usr/lib/systemd/system/clamd@.service
fi
echo " "
ls -lh /etc/mail/spamassassin/local.cf |grep root
if [ $? = 0 ]; then
echo "spamassassin/local.cf SI pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo  "Modificada la pertenencia a root del archivo spamassassin/local.cf"
chown root /etc/mail/spamassassin/local.cf
fi

echo " "

ls -lh /etc/mail/spamassassin/local.cf |grep '\-rw-r--r\--'
if [ $? = 0 ]; then
echo "spamassassin/local.cf Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "Modificados los permisos de acceso a spamassassin/local.cf"
chmod 644 /etc/mail/spamassassin/local.cf
fi
######################################CHROOT############################################
CP="cp -p"

cond_copy() {
  # find files as per pattern in $1
  # if any, copy to directory $2
  dir=`dirname "$1"`
  pat=`basename "$1"`
  lr=`find "$dir" -maxdepth 1 -name "$pat"`
  if test ! -d "$2" ; then exit 1 ; fi
  if test "x$lr" != "x" ; then $CP $1 "$2" ; fi
} 

set -e
umask 022

POSTFIX_DIR=${POSTFIX_DIR-/var/spool/postfix}
cd ${POSTFIX_DIR}

mkdir -p etc lib usr/lib/zoneinfo
test -d /lib64 && mkdir -p lib64

lt=/etc/localtime
if test ! -f $lt ; then lt=/usr/lib/zoneinfo/localtime ; fi
if test ! -f $lt ; then lt=/usr/share/zoneinfo/localtime ; fi
if test ! -f $lt ; then echo "cannot find localtime" ; exit 1 ; fi
rm -f etc/localtime

# copy localtime and some other system files into the chroot's etc
$CP -f $lt /etc/services /etc/resolv.conf /etc/nsswitch.conf etc
$CP -f /etc/host.conf /etc/hosts /etc/passwd etc
ln -s -f /etc/localtime usr/lib/zoneinfo

# copy required libraries into the chroot
cond_copy '/lib/libnss_*.so*' lib
cond_copy '/lib/libresolv.so*' lib
cond_copy '/lib/libdb.so*' lib
if test -d /lib64; then
  cond_copy '/lib64/libnss_*.so*' lib64
  cond_copy '/lib64/libresolv.so*' lib64
  cond_copy '/lib64/libdb.so*' lib64
fi
########################################################################################
echo " "
echo "---------------------------------"
echo "---- CONFIGURACION TERMINADA ----"
echo "---------------------------------"
