#!/bin/bash

clear
vclam=$(ls /usr/share/doc/|grep clamd)

echo "---------------------------------------------------------------------"
echo "--                 CCN-STIC-681-POSTFIX_ENS_SPAM                   --"
echo "--  Antes de ejecutar este script debe asegurarse que los ficheros --"
echo "--       y scripts se encuentran en el directorio /Scripts         --"
echo "---------------------------------------------------------------------"
echo " "
echo "------------------------------------------------------"
echo "-- SE REALIZARA UNA COPIA DE SEGURIDAD DEL ARCHIVO  --"
echo "--        /ETC/MAIL/SPAMASSASSIN/LOCAL.CF           --"
echo "--             /ETC/POSTFIX/MASTER.CF               --"
echo "------------------------------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"
echo " "

fecha=$(date +%d-%m-%Y_%H:%M)

###########################################Spamassassin##################################################
echo " "
echo "------------------------------------------"
echo "-- SE PROCEDE A CONFIGURAR SPAMASSASSIN --"
echo "------------------------------------------"
echo " "

cp -f /etc/mail/spamassassin/local.cf /etc/mail/spamassassin/local.cf.$fecha
cp -f /etc/postfix/master.cf /etc/postfix/master.cf.$fecha

ls /etc/mail/spamassassin/local.cf 
if [ $? = 0 ]; then
echo -e "/etc/mail/spamassassin/local.cf \e[42mEXISTE\e[49m"
sed -i 's/^/#/g' /etc/mail/spamassassin/local.cf
else
echo "Se procedera a crear /etc/mail/spamassassin/local.cf"
mkdir /etc/mail/spamassassin/
sleep 2
touch /etc/mail/spamassassin/local.cf
fi

echo " "
echo " "

cp -f /usr/share/spamassassin/23_bayes.cf /var/log/spamassassin

echo ' 
#Puntacion de marca de spamassassin
required_hits 
#mensaje antepuesto al asunto de mensaje spam
rewrite_header Subject ['']
#encapsular el spam en un adjunto al email de aviso
report_safe 
#habilitar bayes
use_bayes 
#Autoaprendizaje
bayes_auto_learn 
bayes_path /var/log/spamassassin/23_bayes.cf
bayes_file_mode 0666
#Comprobaciones de spam
skip_rbl_checks 
use_razor2 
use_pyzor ' >> /etc/mail/spamassassin/local.cf

gnome-text-editor /etc/mail/spamassassin/local.cf &>/dev/null

gnome-text-editor /etc/postfix/master.cf &>/dev/null
systemctl restart postfix

CP="cp -p"

cond_copy() {
  # find files as per pattern in $1
  # if any, copy to directory $2
  dir=`dirname "$1"`
  pat=`basename "$1"`
  lr=`find "$dir" -maxdepth 1 -name "$pat"`
  if test ! -d "$2" ; then exit 1 ; fi
  if test "x$lr" != "x" ; then $CP $1 "$2" ; fi
} 

set -e
umask 022

POSTFIX_DIR=${POSTFIX_DIR-/var/spool/postfix}
cd ${POSTFIX_DIR}

mkdir -p etc lib usr/lib/zoneinfo
test -d /lib64 && mkdir -p lib64

# find localtime (SuSE 5.3 does not have /etc/localtime)
lt=/etc/localtime
if test ! -f $lt ; then lt=/usr/lib/zoneinfo/localtime ; fi
if test ! -f $lt ; then lt=/usr/share/zoneinfo/localtime ; fi
if test ! -f $lt ; then echo "cannot find localtime" ; exit 1 ; fi
rm -f etc/localtime

# copy localtime and some other system files into the chroot's etc
$CP -f $lt /etc/services /etc/resolv.conf /etc/nsswitch.conf etc
$CP -f /etc/host.conf /etc/hosts /etc/passwd etc
ln -s -f /etc/localtime usr/lib/zoneinfo

# copy required libraries into the chroot
cond_copy '/lib/libnss_*.so*' lib
cond_copy '/lib/libresolv.so*' lib
cond_copy '/lib/libdb.so*' lib
if test -d /lib64; then
  cond_copy '/lib64/libnss_*.so*' lib64
  cond_copy '/lib64/libresolv.so*' lib64
  cond_copy '/lib64/libdb.so*' lib64
fi

postfix reload
postfix check

echo " "
echo "---------------------------------"
echo "---- CONFIGURACION TERMINADA ----"
echo "---------------------------------"
