
#!/bin/bash

clear

fecha=$(date +%d-%m-%Y_%H:%M)

echo "---------------------------------------------------------------------"
echo "--              CCN-STIC-681-POSTFIX-PASO 3.Postmaster             --"
echo "--  Antes de ejecutar este script debe asegurarse que los ficheros --"
echo "--       y scripts se encuentran en el directorio /Scripts         --"
echo "---------------------------------------------------------------------"
echo " "

echo "---------------------------------------------------------------"
echo "-- SE VA A PROCEDER A REALIZAR UN BACKUP DEL ARCHIVO ALIASES --"
echo "---------------------------------------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"

cp -f /etc/aliases /etc/aliases.$fecha

sleep 1
echo "-----------------------------------------------------"
echo "-- BACKUP REALIZADO: /etc/aliases.$fecha --"
echo "-----------------------------------------------------"
echo " "
echo " "


gnome-text-editor /etc/aliases &>/dev/null

echo "-------------------------------"
echo "-- COMPROBANDO CONFIGURACION --"
echo "-------------------------------"

postconf -e "alias_maps = "

postfix check 
if [ $? = 0 ]; then
echo "Configuracion de Postfix:"
echo -e "\e[42mCorrecta\e[49m"
else
echo "Configuracion de Postfix:"
echo -e "\e[41mValor NO conforme\e[49m"
fi


ls -lh /etc/aliases.db
if [ $? = 0 ]; then
echo "Configuracion de aliases:"
echo -e "\e[42mCorrecta\e[49m"
else
echo "Configuracion de aliases:"
echo -e "\e[41mValor NO conforme\e[49m"
echo "Restaure el archivo de respaldo de aliases, ejecute de nuevo el script como superusuario"
fi
echo "---------------------------------"
echo "---- CONFIGURACION TERMINADA ----"
echo "---------------------------------"