#!/bin/bash

clear

fecha=$(date +%d-%m-%Y_%H:%M)

echo "---------------------------------------------------------------------"
echo "--                  CCN-STIC-681-POSTFIX-PASO 7                    --"
echo "--  Antes de ejecutar este script debe asegurarse que los ficheros --"
echo "--       y scripts se encuentran en el directorio /Scripts         --"
echo "---------------------------------------------------------------------"
echo " "
echo "------------------------------------------------------------------"
echo "------------------------------------------------------------"
echo "-- SE COMPROBARA LA INTEGRIDAD DE LOS FICHEROS Y CARPETAS --"
echo "------------------------------------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"

#####################CHEQUEO DE PERTENENCIA Y DERECHOS DE ARCHIVOS POSTFIX

echo " "

ls -lh /etc/postfix/main.cf |grep root
if [ $? = 0 ]; then
echo "main.cf SI pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo "main.cf debera pertenecer a root"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo " "

ls -lh /etc/postfix/main.cf |grep '\-rw-r--r\--'
if [ $? = 0 ]; then
echo "main.cf Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "main.cf deberá cambiar permisos"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo " "

ls -lh /etc/postfix/master.cf |grep root
if [ $? = 0 ]; then
echo "master.cf SI pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo "master.cf debera pertenecer a root"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo " "

ls -lh /etc/postfix/master.cf |grep '\-rw-r--r\--'
if [ $? = 0 ]; then
echo "master.cf Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "master.cf deberá cambiar permisos"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo " "

ls -lh /var/spool/ | grep postfix | grep root
if [ $? = 0 ]; then
echo "/var/spool/postfix SI pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo "/var/spool/postfix debera pertenecer a root"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo " "

ls -lh /var/spool/ | grep postfix | grep rwxr-xr-x.
if [ $? = 0 ]; then
echo "/var/spool/postfix Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "/var/spool/postfix deberá cambiar permisos"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo " "

ls -lh /var/log/maillog |grep root
if [ $? = 0 ]; then
echo "/var/log/maillog SI pertenece a root"
echo -e "\e[42mCorrecto\e[49m"
else
echo "/var/log/maillog debera pertenecer a root"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo " "

ls -lh /var/log/maillog |grep '\-rw\-------'
if [ $? = 0 ]; then
echo "/var/log/maillog Permisos de acceso CORRECTOS"
echo -e "\e[42mCorrecto\e[49m"
else
echo "/var/log/maillog deberá cambiar permisos"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo "  "
echo "  "

echo "-------------------------------------------------------------"
echo "-- SE VA A PROCEDER A LA COMPROBACION DE USUARIOS Y GRUPOS --"
echo "-------------------------------------------------------------"
read -p "Pulse ENTER para continuar o Ctrl + C para cancelar........"

#############CHEQUEO DE LOS GRUPOS POSTFIX Y POSTDROP Y DEL USUARIO POSTFIX CON SHELL /BIN/FALSE
echo "  "
echo "  "

cat /etc/group |egrep "postfix|postdrop"
if [ $? = 0 ]; then
echo "Grupos existentes"
echo -e "\e[42mCorrecto\e[49m"
else
echo "Debera crear los grupos postfix y postdrop"
fi

echo "  "
echo "  "

sleep 2

cat /etc/passwd |egrep -w "postfix|/bin/false"
if [ $? = 0 ]; then
echo "Usuario existente y configurado correctamente"
echo -e "\e[42mCorrecto\e[49m"
else
echo "Debera crear el usuario postfix con shell /bin/false"
echo -e "\e[41mValor NO conforme\e[49m"
fi

cat /etc/passwd |grep dkim
if [ $? = 0 ]; then
echo -e "USUARIO \e[42mopendkim EXISTE\e[49m"
else
echo "Debera crear el usuario opendkim con shell /bin/false"
echo -e "\e[41mValor NO conforme\e[49m"
fi

cat /etc/passwd |grep opendkim |grep false
if [ $? = 0 ]; then
echo -e "USUARIO \e[42mopendkim\e[49m CONFIGURADO: \e[42mCORRECTO\e[49m "
else
echo "Debera modificar al usuario opendkim con shell /bin/false"
echo -e "\e[41mValor NO conforme\e[49m"
fi

echo "  "
echo "  "

echo "---------------------------------"
echo "---- CONFIGURACION TERMINADA ----"
echo "---------------------------------"